Require Import bool.
Require Import connectives.
Require Import leibniz.
Require Import nat.
Parameter bigop_body : forall (H:Type), nat.nat -> (nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H.
Axiom axiom_bigop_body_O : forall H, connectives.equal ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop_body (H) nat.O) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => nil).
Definition eq_bigop_body_O : forall H, leibniz.leibniz ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (bigop_body (H) nat.O) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => nil) := fun (H:Type) => ((((connectives.equal_leibniz) ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H)) (bigop_body (H) nat.O)) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => nil)) ((axiom_bigop_body_O) (H)).
Definition sym_eq_bigop_body_O : forall H, leibniz.leibniz ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => nil) (bigop_body (H) nat.O) := fun (H:Type) => ((((leibniz.sym_leibniz) ((nat.nat -> bool.bool) -> H -> (H -> H -> H) -> (nat.nat -> H) -> H)) (bigop_body (H) nat.O)) (fun (p:(nat.nat -> bool.bool)) => fun (nil:H) => fun (op:(H -> H -> H)) => fun (f:(nat.nat -> H)) => nil)) ((eq_bigop_body_O) (H)).
